var EMV_user_plugin_url = EMV_isValid.plugin_Urls;
var EMV_admin_ajax_url = EMV_isValid.ajax_url;
var EMV_admin_security = EMV_isValid.security;
var EMV_user_input = document.querySelector(".EMV_phone_sms"),
  EMV_user_country_code = document.querySelector("#EMV_country_code"),
  EMV_save_message = document.querySelector(".emv_success_message"),
  EMV_admin_error_msg = document.querySelector(".emv_error_message");

// initialise plugin
let EMV_user_iti = window.intlTelInput(EMV_user_input, {
  utilsScript: EMV_user_plugin_url + "assets/js/utils.js",
});

var EMV_reset = function () {
  EMV_user_input.classList.remove("invalid");
  EMV_user_input.classList.remove("valid");
  EMV_save_message.classList.add("message_show");
  EMV_admin_error_msg.classList.add("message_show");
};
EMV_user_input.addEventListener("blur", function () {
  EMV_reset();
  if (EMV_user_input.value.trim()) {
    if (EMV_user_iti.isValidNumber()) {
      EMV_user_input.classList.remove("invalid");
      EMV_user_input.classList.add("valid");
    } else {
      EMV_user_input.classList.remove("valid");
      EMV_user_input.classList.add("invalid");
    }
  }
});
EMV_user_input.addEventListener("change", EMV_reset);
EMV_user_input.addEventListener("keyup", EMV_reset);

jQuery(document).on("click", ".emv_phone_button", function (e) {
  EMV_reset();
  if (EMV_user_input.value.trim()) {
    if (EMV_user_iti.isValidNumber()) {
      var submit_button_obj = jQuery(this);
      EMV_user_input.classList.remove("invalid");
      EMV_user_input.classList.add("valid");
      var phone_number = jQuery(this)
        .closest(".emv_admin_phone")
        .find(".EMV_phone_sms")
        .val();
      var country_code = jQuery(this)
        .closest(".emv_admin_phone")
        .find(".EMV_country_code")
        .val();
      var numbers_with_country = country_code + phone_number;
      var rep = numbers_with_country.replace("-", "");
      var phone_number_trim = jQuery.trim(rep);

      if (phone_number == "") {
        return false;
      } else if (country_code == "") {
        return false;
      } else {
        var data = {
          action: "emv_save_amdin_phone",
          phone: phone_number_trim,
          security: EMV_admin_security,
        };
        jQuery.ajax({
          type: "POST",
          url: EMV_admin_ajax_url,
          data: data,
          success: function (msg) {
            EMV_save_message.classList.remove("message_show");
          },
        });
      }
    } else {
      EMV_user_input.classList.remove("valid");
      EMV_user_input.classList.add("invalid");
      EMV_save_message.classList.add("message_show");
      EMV_admin_error_msg.classList.remove("message_show");
    }
  }
  return false;
});

jQuery("#EMV_toggle").click(function () {
  if (jQuery(this).val() == 1) jQuery(this).val(0);
  else if (jQuery(this).val() == 0) jQuery(this).val(1);
});
jQuery("#EMV_toggle_2").click(function () {
  if (jQuery(this).val() == 1) jQuery(this).val(0);
  else if (jQuery(this).val() == 0) jQuery(this).val(1);
});
// on keyup / change flag: reset
