(function ($) {
  let emv_ajax_url = EMV_vendor_list.ajax_url;
  let emv_security = EMV_vendor_list.security;
  let emv_security2 = EMV_vendor_list.security2;
  let emv_security3 = EMV_vendor_list.security3;
  let emv_edit_mode = EMV_vendor_list.edit_mode;
  let emv_security4 = EMV_vendor_list.security4;
  $(".emv_single_sendSms").on("click", function (e) {
    e.preventDefault();
    let self = $(this);
    let parent = self.parents("tr");
    let dataId = parent.find(".phone a").attr("emv_data_id");
    let emvData = {
      action: "emv_manual_sendSMS",
      emv_data_id: dataId,
      security: emv_security,
    };
    $.ajax({
      url: emv_ajax_url,
      type: "POST",
      data: emvData,
      success: function (data) {
        location.reload();
      },
    });
    return false;
  });
  /**
   * multiple sms send use bulk action
   */
  $(".action").on("click", function () {
    let self = $(this);
    let selected = $("#bulk-action-selector-top").val();
    if ("emv_send_sms" == selected) {
      let vendorIDS = [];
      //   return false;
      $.each($(".emv_number_list_check"), function (index, elem) {
        if ($(elem).prop("checked")) {
          let vendorID = $(elem)
            .parents("tr")
            .find(".phone .send_sms .emv_api_data")
            .attr("emv_data_id");
          vendorIDS.push(vendorID);
        }
      });
      console.log(vendorIDS);
      let bulKData = {
        action: "emv_bulk_sms",
        vendorIDS: vendorIDS,
        security: emv_security4,
      };
      $.ajax({
        url: emv_ajax_url,
        type: "POST",
        data: bulKData,
        success: function (data) {
          // console.log(data);
          if (data.message == true) {
            alert("Please select WhatsApp number.");
          } else {
            $(".emv_wrap_list").html("");
            $(".emv_wrap_list").html(
              "<div class='emv_sms_count'><div class='emv_sms_sent'><span class='dashicons dashicons-yes-alt'></span> SMS Sent : " +
                data.send +
                "</div><div class='emv_sms_failed'><span class='dashicons dashicons-dismiss'></span> SMS Failed : " +
                +data.failed +
                "</div></div>"
            );
          }
        },
      });
    } else if (-1 == selected) {
      alert("Please select");
    }
    return false;
  });

  /**
   * View message
   *
   * @version 1.0.0
   */
  $(".emv_current_message_main").on("click", function () {
    let self = $(this);
    let vendor_id = self.find(".emv_msg_vendor_id").val();
    self.find(".emv_msg_view").css("display", "none");
    self.find(".emv_msg_awoiting").css("display", "none");
    self.find(".emv_current_msg").css("display", "block");

    let delete_transient = {
      action: "emv_delete_transient",
      vendor_id: vendor_id,
      security: emv_security2,
    };
    $.ajax({
      url: emv_ajax_url,
      type: "POST",
      data: delete_transient,
      success: function (data) {},
    });
    return false;
  });

  $(".emv_manual_popup_button").on("click", function (e) {
    e.preventDefault();
    let self = $(this).parent();
    jQuery(".emv_admin_manual_popup1 , .emv_admin_manual_popup ").removeClass(
      "active"
    );
    self.find(".emv_admin_manual_popup").addClass("active");
    self.find(".emv_close_button").on("click", function (e) {
      e.preventDefault();
      var self = $(this);
      self.parent().removeClass("active");
    });
    var phone_number = self.find("#emv_vendor_phone_number").val();
    var vendor_id = self.find("#emv_vendor_shop_id").val();
    var form_shop = self.find("#emv_main_shop_name").val();
    var vendor_shop = self.find("#emv_vendor_shop_name").val();
    var vendor_id = self.find("#emv_vendor_shop_id").val();
    var message_subject = self.find("#emv_manual_sub_value").val();
    var message_desc = self.find("#emv_manual_text_value").val();
    message_subject = message_subject.replace("{vendorShopName}", vendor_shop);
    message_desc = message_desc.replace("{vendorShopName}", vendor_shop);
    self
      .find("#emv_manual_sub_value , #emv_manual_text_value")
      .keyup(function (e) {
        let subject = self.find("#emv_manual_sub_value").val();
        let message = self.find("#emv_manual_text_value").val();
        subject = subject.replace("{vendorShopName}", vendor_shop);
        message = message.replace("{vendorShopName}", vendor_shop);

        var trim_value11 = jQuery.trim(subject);
        var emv_length11 = trim_value11.length;
        var trim_value22 = jQuery.trim(message);
        var emv_length22 = trim_value22.length;
        if (emv_length11 > 0 && emv_length22 > 0) {
          self.find(".emv_manual_empty_message").html("");
          var permalink =
            "https://api.whatsapp.com/send?phone=" +
            phone_number +
            "&text=" +
            "From : " +
            form_shop +
            "%0D%0A" +
            "Subject : " +
            subject +
            "%0D%0A" +
            "Message : " +
            message +
            "&source=&data=";
          self.find(".emv_menual_phone_button").attr("href", permalink);
        } else {
          self.find(".emv_menual_phone_button").removeAttr("href");
          self
            .find(".emv_manual_empty_message")
            .html(
              "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
                "Empty fields are not allowed" +
                "</div>"
            );
        }
      });
    var trim_value = jQuery.trim(message_subject);
    var emv_length = trim_value.length;
    var trim_value2 = jQuery.trim(message_desc);
    var emv_length2 = trim_value2.length;
    if (emv_length > 0 && emv_length2 > 0) {
      self.find(".emv_manual_empty_message").html("");
      var permalink =
        "https://api.whatsapp.com/send?phone=" +
        phone_number +
        "&text=" +
        "From : " +
        form_shop +
        "%0D%0A" +
        "Subject : " +
        message_subject +
        "%0D%0A" +
        "Message : " +
        message_desc +
        "&source=&data=";
      self.find(".emv_menual_phone_button").attr("href", permalink);
    } else {
      self.find(".emv_menual_phone_button").removeAttr("href");
      self
        .find(".emv_manual_empty_message")
        .html(
          "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
            "Empty fields are not allowed" +
            "</div>"
        );
    }
    return false;
  });

  //for api
  $(".emv_api_popup_button").on("click", function (e) {
    e.preventDefault();
    let self = $(this).parent();
    jQuery(".emv_admin_manual_popup , .emv_admin_manual_popup1 ").removeClass(
      "active"
    );
    self.find(".emv_admin_manual_popup1").addClass("active");
    self.find(".emv_close_button1").on("click", function (e) {
      e.preventDefault();
      var self = $(this);
      self.parent().removeClass("active");
    });
    self.find(".emv_menual_phone_button1").on("click", function (e) {
      e.preventDefault();
      var vendor_shop = self.find("#emv_vendor_shop_name1").val();
      var vendor_id = self.find("#emv_vendor_shop_id1").val();
      var message_subject = self.find("#emv_manual_sub_value1").val();
      var message_desc = self.find("#emv_manual_text_value1").val();
      message_subject = message_subject.replace(
        "{vendorShopName}",
        vendor_shop
      );
      message_desc = message_desc.replace("{vendorShopName}", vendor_shop);
      var trim_value = jQuery.trim(message_subject);
      var emv_length = trim_value.length;
      var trim_value2 = jQuery.trim(message_desc);
      var emv_length2 = trim_value2.length;

      if (emv_length > 0 && emv_length2 > 0) {
        self.find(".emv_manual_empty_message1").html("");

        let apiData = {
          action: "emv_api_popup_sms",
          subject: message_subject,
          message: message_desc,
          vendorIDS: vendor_id,
          security: emv_security3,
        };
        $.ajax({
          url: emv_ajax_url,
          type: "POST",
          data: apiData,
          success: function (msg) {
            self.find(".emv_manual_empty_message1").html("");
            if (msg.message == true) {
              self
                .find(".emv_manual_empty_message1")
                .html(
                  "<div class='emv_availity_success'><span class='dashicons dashicons-yes-alt'></span>" +
                    "SMS send successfully!" +
                    "</div>"
                );
              // location.reload();
            } else {
              self.find(".emv_manual_empty_message1").html("");
              self
                .find(".emv_manual_empty_message1")
                .html(
                  "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
                    "SMS send failed!" +
                    "</div>"
                );
              // location.reload();
            }
          },
        });
      } else {
        self.find(".emv_manual_empty_message1").html("");
        self
          .find(".emv_manual_empty_message1")
          .html(
            "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
              "Empty fields are not allowed" +
              "</div>"
          );
      }
    });

    return false;
  });
})(jQuery);
