(function () {
  /*jshint eqeqeq:false curly:false latedef:false */
  "use strict";
  var EMV_user_plugin_url = EMV_localize_data.plugin_Urls;
  var emv_vendor_ajax_url = EMV_localize_data.emv_vendor_ajax_url;
  var emv_vendor_security = EMV_localize_data.emv_vendor_security;
  var emv_phone_number = EMV_localize_data.phone_number;
  var vendor_chat_availity = EMV_localize_data.vendor_chat_availity;
  var emv_send_security = EMV_localize_data.emv_send_security;
  var emv_api_active = EMV_localize_data.api_active;
  var emv_vendor_active = EMV_localize_data.venodr_api_active;
  var availity_message = EMV_localize_data.availity_message;
  var availity_message2 = EMV_localize_data.availity_message2;
  var EMV_user_input = document.querySelector("#EMV_phone"),
    EMV_user_country_code = document.querySelector("#EMV_country_code"),
    EMV_user_ererrorMsg = document.querySelector("#EMV_error_msg"),
    EMV_user_validMsg = document.querySelector("#EMV_valid_msg"),
    EMV_user_validation = document.querySelector(
      ".woocommerce-form-register__submit"
    );
  // initialise plugin
  if (EMV_user_input != null) {
    var EMV_user_iti = window.intlTelInput(EMV_user_input, {
      utilsScript: EMV_user_plugin_url + "assets/js/utils.js",
    });

    var emv_reset = function () {
      jQuery(".EMV_dokan_phone_sms").removeClass("emv_valid");
      jQuery(".EMV_dokan_phone_sms").removeClass("emv_invalid");
    };
    EMV_user_input.addEventListener("blur", function () {
      emv_reset();
      if (EMV_user_input.value.trim()) {
        if (EMV_user_iti.isValidNumber()) {
          jQuery(".EMV_dokan_phone_sms").addClass("emv_valid");
          jQuery(".EMV_dokan_phone_sms").removeClass("emv_invalid");
        } else {
          jQuery(".EMV_dokan_phone_sms").addClass("emv_invalid");
          jQuery(".EMV_dokan_phone_sms").removeClass("emv_valid");
        }
      }
    });
    if (EMV_user_validation != null) {
      EMV_user_validation.addEventListener("click", function () {
        if (EMV_user_input.value.trim()) {
          if (EMV_user_iti.isValidNumber()) {
            return true;
          } else {
            EMV_user_input.value = "";
            EMV_user_country_code.value = "";
          }
        }
      });
    }

    jQuery(document).on("click", ".emv_dokan_save", function (e) {
      e.preventDefault();
      if (EMV_user_input.value.trim()) {
        if (EMV_user_iti.isValidNumber()) {
          var submit_button_obj = jQuery(this);
          var current_user_id = submit_button_obj
            .closest(".EMV_sub_main")
            .find(".emv_current_user_id")
            .val();
          var phone_number = submit_button_obj
            .closest(".EMV_sub_main")
            .find(".EMV_dokan_phone_sms")
            .val();
          var countryCode = submit_button_obj
            .closest(".EMV_sub_main")
            .find(".EMV_country_code")
            .val();
          var full_number = countryCode + phone_number;
          var data = {
            action: "emv_vendor_save",
            vendor_id: current_user_id,
            emv_phone: full_number,
            security: emv_vendor_security,
            dataobj: "emv_vendor",
          };

          if (jQuery.fn.block) {
            submit_button_obj.closest(".EMV_sub_main").block({
              message: null,
            });
          } else {
            var overlay = jQuery('<div id="emv-bis-overlay"> </div>');
            overlay.appendTo(submit_button_obj.closest(".EMV_sub_main"));
          }
          //ajax
          jQuery.ajax({
            type: "post",
            url: emv_vendor_ajax_url,
            data: data,
            success: function (msg) {
              location.reload();
              if (jQuery.fn.block) {
                submit_button_obj.closest(".EMV_sub_main").unblock();
              } else {
                submit_button_obj
                  .closest(".EMV_sub_main")
                  .find("#emv-bis-overlay")
                  .fadeOut(400, function () {
                    submit_button_obj
                      .closest(".EMV_sub_main")
                      .find("#emv-bis-overlay")
                      .remove();
                  });
              }
            },
            error: function (request, status, error) {
              //jQuery.unblockUI();
              if (jQuery.fn.block) {
                submit_button_obj.closest(".EMV_sub_main").unblock();
              } else {
                submit_button_obj
                  .closest(".EMV_sub_main")
                  .find("#emv-bis-overlay")
                  .fadeOut(400, function () {
                    submit_button_obj
                      .closest(".EMV_sub_main")
                      .find("#emv-bis-overlay")
                      .remove();
                  });
              }
            },
          });
        }
        return false;
      }
      return false;
    });

    // on blur: validate

    // on keyup / change flag: reset
    EMV_user_input.addEventListener("change", emv_reset);
    EMV_user_input.addEventListener("keyup", emv_reset);
  }

  jQuery(document).ready(function () {
    jQuery("#emv_verndor_text").keyup(function () {
      var emv_message = jQuery("#emv_verndor_text").val();
      var trim_value = jQuery.trim(emv_message);
      var emv_length = trim_value.length;
      if (
        emv_length > 0 &&
        emv_phone_number !== "" &&
        vendor_chat_availity != 1 &&
        (emv_api_active != 1 || emv_vendor_active != 1)
      ) {
        jQuery(".admin_phone_number_empty_message").html(" ");
        var shop_name = jQuery("#emv_shop_name").val();
        var emv_name = jQuery("#emv_display_name").val();
        var permalink =
          "https://api.whatsapp.com/send?phone=" +
          emv_phone_number +
          "&text=" +
          "Name : " +
          emv_name +
          "%0D%0A" +
          "Shop Name : " +
          shop_name +
          "%0D%0A" +
          "Message : " +
          emv_message +
          "&source=&data=";
        jQuery("#emv_send_button").attr("href", permalink);
      } else {
        jQuery("#emv_send_button").removeAttr("href");

        jQuery(".admin_phone_number_empty_message").html(
          "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
            "Empty message are not allowed!" +
            "</div>"
        );
      }
      if (emv_length > 0) {
        jQuery(".admin_phone_number_empty_message").html(" ");
        jQuery(document)
          .off()
          .on("click", "#emv_send_button", function (e) {
            var submit_button_obj = jQuery(this);
            if (emv_phone_number === "") {
              submit_button_obj
                .closest(".EMV_dokan_section")
                .find(".admin_phone_number_empty_message")
                .html(
                  "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
                    availity_message +
                    "</div>"
                );
              return false;
            }
            if (vendor_chat_availity == 1) {
              submit_button_obj
                .closest(".EMV_dokan_section")
                .find(".admin_phone_number_empty_message")
                .html(
                  "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
                    availity_message2 +
                    "</div>"
                );
              return false;
            }
            var message = submit_button_obj
              .closest(".EMV_live_Chat")
              .find("#emv_verndor_text")
              .val();
            var current_vendor_id = submit_button_obj
              .closest(".EMV_live_Chat")
              .find(".emv_current_user_id")
              .val();
            var data = {
              action: "emv_vendor_send_sms",
              admin_phone: emv_phone_number,
              message: message,
              vendor_id: current_vendor_id,
              security: emv_send_security,
              dataobj: "emv_send_sms",
            };

            //ajax
            jQuery.ajax({
              type: "post",
              url: emv_vendor_ajax_url,
              data: data,
              success: function (msg) {
                submit_button_obj
                  .closest(".EMV_live_Chat")
                  .find("#emv_verndor_text")
                  .val("");
                jQuery("#emv_send_button").removeAttr("href");
                if (msg.message == true) {
                  submit_button_obj
                    .closest(".EMV_dokan_section")
                    .find(".admin_phone_number_empty_message")
                    .html(
                      "<div class='emv_availity_success'><span class='dashicons dashicons-yes-alt'></span>" +
                        "SMS send successfully!" +
                        "</div>"
                    );
                } else {
                  submit_button_obj
                    .closest(".EMV_dokan_section")
                    .find(".admin_phone_number_empty_message")
                    .html(
                      "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
                        "SMS send failed." +
                        "</div>"
                    );
                }
              },
              error: function (request, status, error) {
                //jQuery.unblockUI();
              },
            });
          });
      } else {
        jQuery(".admin_phone_number_empty_message").html(
          "<div class='emv_availity_error'><span class='dashicons dashicons-dismiss'></span>" +
            "Empty message are not allowed!" +
            "</div>"
        );
      }
    });
  });
})(jQuery);
