<?php
/**
 * Register esay to manage vendor Menu
 * @return object
 * @version 1.0.0
 */
if ( ! defined('ABSPATH') ) {
    exit;
}

 if ( ! class_exists( 'EMV_Menu' ) ) {
    /**
     * Emv register Menu class
     * 
     * @version 1.0.0
     */
    class EMV_Menu {
        /**
         * Public @var
         * Store another class instance
         * 
         * @version 1.0.0
         */
        public $numbersList, $Setting;
        /**
         * Calling Method 
         * 
         * @return void
         * @version 1.0.0
         */
        public function __construct() {
            add_action('admin_menu', [ $this,'_register_menu' ], 11 );
            $this->numbersList = new EMV_Numbers();
            $this->Setting     = new EMV_Setting();
        }
        /**
         * Register EMV menu items
         * 
         * @return void
         * @version 1.0.0
         */
        public function _register_menu() {
            add_menu_page( __( 'Chat With Vendor', 'EMV' ),__( 'Chat With Vendor',' EMV' ), 'manage_woocommerce','esay-to-manage-vendor',[ $this->numbersList,'emv_numbers_list' ],EMV_ASSETS.'/img/user+whatsapp.svg', 40 );
            add_submenu_page( 'esay-to-manage-vendor', __( 'All Numbers', 'EMV' ), __( 'All Numbers', 'EMV'), 'manage_woocommerce','esay-to-manage-vendor',[ $this->numbersList,'emv_numbers_list' ] );
            add_submenu_page( 'esay-to-manage-vendor',  __( 'Settings', 'EMV' ),__('Settings', 'EMV'), 'manage_woocommerce','emv_settings',[ $this->Setting, 'setting_pages'] );
        }
    }
    /**
     * Call to construct
     */
    new EMV_Menu();
 }