
<?php

/**
 * List out all vendors numbers.
 * @return void
 * @version 1.0.0
 */
if ( ! defined('ABSPATH') )
{
    exit;
}
if( ! class_exists( 'WP_List_Table' ) ) {
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

if ( !class_exists( 'EMV_numbers_list' ) ) {
   
    class EMV_numbers_list extends WP_List_Table{
        function __construct() {
            parent::__construct( [
                'singular' => 'contact',
                'plural'   => 'contacts',
                'ajax'     => true
            ] );
        }
    
        /**
         * use for temp
         * @var array
         * @version 1.0.0
         */
        private $_items;

      /**
       * Set vendor data
       */  
      function set_data( $data ) {
           $this->_items = $data;
       }

       /**
        * add columns for show data
        */
       function get_columns() {
            return [
                'cb'          => '<input type="checkbox" class="emv_number_list_check" />',
                'phone'    => __('WhatsApp Numbers','EMV'),
                'status'      => __('Status','EMV'),
                'vendor'      => __('Shop Name','EMV'),
                'current_msg' => __('Last Message','EMV'),
                'register'    => __('Register','EMV'),
            ];
       }
        /**
         * call cb column for some change
         * @override WP_List_Table
         */
        public function column_current_msg( $item ) {
            if ( empty( $item['current_msg']['message'] ) ) {
                return "<strong>No massage found</strong>";
            } else {
                if ( empty( $item['current_msg']['awaiting'] ) ) {
                    $newform = sprintf('<div class="emv_current_message_main"><input type="hidden" class="emv_msg_vendor_id" value="%s"/><div class="emv_msg_view">View..</div><div class="emv_current_msg" style="display:none">%s</div> </div>',$item['id'], $item['current_msg']['message']);
                } else {
                    $newform = sprintf('<div class="emv_current_message_main"><input type="hidden" class="emv_msg_vendor_id" value="%s"/><div class="emv_msg_view">View..</div><span class="emv_msg_awoiting awaiting-mod">%s</span><div class="emv_current_msg" style="display:none">%s</div> </div>',$item['id'],  $item['current_msg']['awaiting'], $item['current_msg']['message']);
                }
            }
            return $newform;
        }

       /**
        * set bulk action for send multiple sms
        *@return array
        *@override WP_List_Table
        */
       function get_bulk_actions() {
        $actions = [
            'emv_send_sms'    => 'Send SMS'
        ];
          return $actions;
       }
       
    
       /**
        * WP List table Row action
        *@return array
        *@override WP_List_Table
        */
        function handle_row_actions( $item, $column_name, $primary ) {
           
            if ( $column_name !== $primary ) {
                return ' ';
            }
            $itemId     = $item['id'];
            $phone   = $item['phone'];

            if ( $phone === 'Number not given' ) {
                return ' ';
            }
            $userInfo         = get_userdata( $itemId );
            $shop_name        = $userInfo->user_nicename;
            $from_name        = get_bloginfo( 'name' );
            $button_name      = __( 'Send on WhatsApp', 'EMV' );
            $emv_sub          = get_option ( 'emv_message_subject' );
            $emv_sub1         = str_replace( '{vendorShopName}', $shop_name, $emv_sub );
            $emv_message      = get_option ( 'emv_message_desc' );
            $emv_message1     = str_replace( '{vendorShopName}', $shop_name, $emv_message );
            $enable_edit_mode = get_option( 'emv_enable_edit_mode', 1 );
            $enable_api_edit_mode = get_option( 'emv_enable_api_edit_mode', 1 );
            $api_url = 'https://api.whatsapp.com/send?phone=' . $phone . '&text=' . 'From : ' . $from_name . '%0D%0A' . 'Subject : ' . $emv_sub1 . '%0D%0A' . 'Message : ' . $emv_message1 . '&source=&data=';
            
            $common_variable = sprintf(
               '<span class="emv_empty_close"></span>
                <span class="emv_close_button"><span class="dashicons dashicons-no-alt"></span></span>
                <div class="emv_message_area">
                    <div class="emv_manual_form_header">%s</div>
                    <div class="emv_manual_contant">
                        <label>We can write shortcodes for sending messages. use {vendorShopName}.</label>
                        <div class="emv_manual_empty_message"></div>
                        <input type="hidden" id="emv_vendor_shop_name" value="%s"/>
                        <input type="hidden" id="emv_vendor_shop_id" value="%s"/>
                        <input type="text" id="emv_vendor_phone_number" value="%s" disabled/>
                        <input type="hidden" id="emv_main_shop_name"  value="%s"/>
                        <input type="text" id="emv_manual_sub_value" placeholder="Enter subject here" class="emv_manual_sub_value"  value="%s"/>
                        <textarea id="emv_manual_text_value" rows="7"  placeholder="Enter message here" >%s</textarea>
                        <a target="_blank" class="emv_menual_phone_button">%s</a>
                    </div>
                </div>','Contact on WhatsApp', $shop_name, $itemId, $phone, $from_name, $emv_sub, $emv_message, $button_name 
            );
            $common_variable1 = sprintf(
                '<span class="emv_empty_close1"></span>
                 <span class="emv_close_button1"><span class="dashicons dashicons-no-alt"></span></span>
                 <div class="emv_message_area1">
                     <div class="emv_manual_form_header1">%s</div>
                     <div class="emv_manual_contant1">
                         <label>We can write shortcodes for sending messages. use {vendorShopName}.</label>
                         <div class="emv_manual_empty_message1"></div>
                         <input type="hidden" id="emv_vendor_shop_name1" value="%s"/>
                         <input type="hidden" id="emv_vendor_shop_id1" value="%s"/>
                         <input type="text" id="emv_vendor_phone_number1" value="%s" disabled/>
                         <input type="text" id="emv_manual_sub_value1" placeholder="Enter subject here" class="emv_manual_sub_value1"  value="%s"/>
                         <textarea id="emv_manual_text_value1" rows="7"  placeholder="Enter message here" >%s</textarea>
                         <a target="_blank" class="emv_menual_phone_button1">%s</a>
                     </div>
                 </div>','Contact on WhatsApp', $shop_name, $itemId, $phone, $emv_sub, $emv_message, $button_name 
             );
            //for api
            $popup1 = sprintf(
                '<div class="emv_admin_manual_popup1">
                    %s
                </div>',$common_variable1 );
            // for rest
            $popup = sprintf(
                '<div class="emv_admin_manual_popup">
                    %s
                </div>', $common_variable );
            $action = [];
            $caption3    = sprintf('<img style="width:25px;height:17px;margin-bottom:-3px" src="%s" alt="%s" />',EMV_URL.'assets/img/automate.svg',"vendor sms");
            $caption     = sprintf('<img class="emv_api_popup_button" style="width:25px;height:17px;margin-bottom:-3px" src="%s" alt="%s" />',EMV_URL.'assets/img/automate.svg',"vendor sms");
            $caption2    = sprintf('<img class="emv_manual_popup_button" style="width:25px;height:17px;margin-bottom:-3px" src="%s" alt="%s" />',EMV_URL.'assets/img/manual_send.svg',"menual vendor sms");
            $caption4    = sprintf('<img style="width:25px;height:17px;margin-bottom:-3px" src="%s" alt="%s" />',EMV_URL.'assets/img/manual_send.svg',"menual vendor sms");
            if ( $enable_api_edit_mode == '1' ) {
                $action['send_sms'] = sprintf('<div emv_data_id="'.$itemId.'" class="emv_manual_api_main emv_api_data"> %s %s</a>', $popup1, $caption );
            } else {
                $action['send_sms'] = sprintf('<a emv_data_id="'.$itemId.'" href="%s" class="emv_single_sendSms emv_api_data">%s</a>','#',$caption3);
            }
            if ( $enable_edit_mode == '1' ) {
                $action['manual_sms'] = sprintf('<div emv_data_id="'.$itemId.'" class="emv_manual_main">%s %s</div>',$caption2, $popup);
            } else {
                $action['manual_sms'] = sprintf('<a emv_data_id="'.$itemId.'" class="emv_manual_sms_free" target="_blank" href="%s">%s</a>', $api_url, $caption4 );
            }
            return $this->row_actions($action,true);
        }

       /**
        * add extra_tablenav for data filter
        *@override WP_List_Table
        */
        function extra_tablenav($which) {
           
        if ('top' == $which ) :
            ?>
                <div class="actions alignleft">
                    <select name="emv_felter_s" id="emv_felter_s">
                        <option value="all"><?php _e( 'All', 'EMV' ); ?></option>
                        <option value="Unsend"><?php _e( 'Unsend', 'EMV' );?></option>
                        <option value="send"><?php _e( 'Send', 'EMV' ); ?></option>
                        <option value="failed"><?php _e('Failed', 'EMV' ); ?></option>
                    </select>
                    <?php
                    submit_button(__("Filter","tableData"), __('button', 'EMV' ),__( 'submit', 'EMV' ), false );
                    ?>
                </div>
             <?php
        endif;
       }

       /**
        * call cb column for some change
        *@override WP_List_Table
        */
       function column_cb( $item ) {
            return "<input type='checkbox' class='emv_number_list_check' value='{$item['id']}' />";
       }
       /**
        * call phone column for some change
        * @override WP_List_Table
        */
       function column_status( $item ) {   
            if ( $item['status']== 'send' ) {
                return "<span class='emv_sms_sent'>{$item['status']}</span>";
            } else if ( $item['status']== 'failed' ) {
                return "<span class='emv_sms_failed'>{$item['status']}</span>";
            } else {
                return "<span class='emv_sms_unsend'>{$item['status']}</span>";
            }
            
        }

        /**
         * call status column
         * @override WP_List_Table
         */

        function column_phone($item) {
            if ( $item['phone'] == 'Number not given' ) {
                return "<span class='number_not_given'>{$item['phone']}</span>";
            }
            return "<strong>{$item['phone']}</strong>";
        }
        /**
         * add Sortable columns phone and vendor
         */
        function get_sortable_columns() {
            return [
                'phone' => ['phone',true],
                'vendor'   => ['vendor',true],
                'register' => ['register',true],
                ];
        }

        /**
         * call to ation WP_List_Table
         * @override WP_List_Table
         */
       function prepare_items() {
            $paged                 =  isset( $_REQUEST['paged'] ) ? intval( sanitize_text_field( $_REQUEST['paged'] ) ) : 1 ;
            $total_items           = count($this->_items);
            $per_page              = get_option( 'emv_per_page', 10 );
            $data_chunk            = array_chunk($this->_items,$per_page);
            $this->items           = !empty( $data_chunk ) ? $data_chunk[$paged-1] : $total_items;
            $this->_column_headers = array($this->get_columns(),array(),$this->get_sortable_columns());
            
            #set pagination
            $this->set_pagination_args([
            'total_items'   => $total_items,
            'per_page'      => $per_page,
            'total_pages'   => ceil(count($this->_items)/$per_page)
            ]); 
       
        }

        /**
         * set columns
         */
        function column_default($item, $column_name) {
            return $item[$column_name];
        }

    }
  
   
}