<?php
/**
 *  EMV Setting / Vendor List Table
 */
if ( ! defined('ABSPATH') )
{
    exit;
}
if ( !class_exists( "EMV_Setting" ) ) {
    class EMV_Setting {
        /**
         * Setting pages callback
         * @return void
         * @version 1.0.0
         */
        public function setting_pages() {
            $phone_number = get_option( 'EMV_admin_phone_number', '' );
            ?>
            <div class="EMV_Main">
                <div class="emv_success_message message_show" ><span class="dashicons dashicons-saved emv_save_style"></span><?php _e( 'Save Successfully!', 'EMV' ); ?></div>
                <div class="emv_error_message message_show" ><span class="dashicons dashicons-no emv_error_style"></span><?php _e('Invalid Number!','EMV');?></div>
                <div class="EMV_section">
                    <div class="EMV_header">
                        <div class="EMV_header_section">
                            <div class="EMV_logo_section">
                            <?php
                                printf('<img src="%s" alt="Chat with Vendor" class="%s"/>',EMV_ASSETS.'/img/user+whatsapp.svg','EMV_logo');
                            ?>
                            </div>
                            <div class="EMV_title_section">
                                <div class="Ecv_title">
                                <?php _e( 'Easy Chat with Vendor', 'EMV' );?>
                                </div>
                                <div class="Ecv_description">
                                    <?php _e( 'Easy way to communicate with vendor systems','EMV');?>
                                </div>
                            </div>
                        </div>
                        <div class="emv_phone emv_admin_phone">
                            
                            <div class="EMV_input">
                                <div class="EMV_phone">
                                    <input type="hidden" name="EMV_country_code" id="EMV_country_code" class="EMV_country_code">
                                    <input  type="tel" id="EMV_phone" name="EMV_phone_number" class="EMV_phone_sms" required="required" value="<?php echo esc_attr($phone_number); ?>">
                                    <span id="emv_phone_button" class="dashicons dashicons-saved emv_phone_button"></span>
                                    <span class="dashicons dashicons-warning emv_tooltip" title="Please enter your whatsApp number . The Vendor will contact you through this number."></span>
                                </div>
                            </div>
                           
                        </div>
                    </div>
                    <?php
                    printf('<div class="emv_setting_page" id="emv_setting_page"> </div>');
                    ?>     
                </div>
            </div>
        <?php
        }
    }

    new EMV_Setting();
}