<?php
if ( ! defined('ABSPATH') ) {
    exit;
}

if ( ! class_exists('EMV_Dokan_Menu') ) {
    class EMV_Dokan_Menu {
        function __construct() {
            add_action( 'init', array( $this, 'add_endpoint' ) );
            // add_filter( 'dokan_query_var_filter', array($this,'dokan_emv_query' ));
            add_action( 'dokan_load_custom_template', array($this,'emv_load_template'));
            add_filter( 'dokan_get_dashboard_nav', array($this,'dokan_add_emv_menu' ));
            add_action( 'dokan_dashboard_content_after', [ $this, 'emv_popup_footer'] );
        }
        public function add_endpoint() {
			add_rewrite_endpoint( 'emv_chat', EP_PAGES );
            flush_rewrite_rules();
		}
        /**
         * Show empty phone number popup
         *
         * @version 1.0.0
         */
        public function emv_popup_footer () {
            do_action( 'emv_empty_phone_number_popup' );
        }
        // public function dokan_emv_query( $query_vars ) {
        //     $query_vars['emv_chat'] = 'emv_chat';
        //     return $query_vars;
        // }

        public function dokan_add_emv_menu($urls ) {
            $helper = new EMV_helper();
            if ( $helper->emv_can_vendor() ) {
                $urls['emv_chat'] = array(
                    'title' => __( 'Chat with Admin', 'EMV'),
                    'icon'  => sprintf( '<img style="width: 20px;margin-right: 8px;" src="%s/img/user+whatsapp.svg" />', EMV_ASSETS ),
                    'url'   => dokan_get_navigation_url( 'emv_chat' ),
                    'pos'   => 51
                );
            }
            return $urls;
        }
        public function emv_load_template( $query_vars ) {
            if ( isset( $query_vars['emv_chat'] ) ) {
              
              ?>
              <?php
                /**
                 *  Dokan Dashboard Template
                 *
                 *  Dokan Main Dahsboard template for Fron-end
                 *
                 *  @since 2.4
                 *
                 *  @package dokan
                 */
                ?>
                <div class="dokan-dashboard-wrap">
                    <?php
                        /**
                         *  dokan_dashboard_content_before hook
                         *
                         *  @hooked get_dashboard_side_navigation
                         *
                         *  @since 2.4
                         */
                        do_action( 'dokan_dashboard_content_before' );
                    ?>

                    <div class="dokan-dashboard-content">
                    <?php
                        /**
                         *  dokan_dashboard_content_before hook
                         *
                         *  @hooked show_seller_dashboard_notice
                         *
                         *  @since 2.4
                         */
                        do_action( 'dokan_help_content_inside_before' );
                        /**
                         * EMV Vendor Chatting form
                         *
                         * @version 1.0.0
                         */
                        do_action('emv_chat_with_system_admin_form', 'dokan', 1 );
                    
                        ?>
                        <article class="help-content-area">
                           
                        </article><!-- .dashboard-content-area -->
                        <?php
                            /**
                             *  dokan_dashboard_content_inside_after hook
                             *
                             *  @since 2.4
                             */
                            do_action( 'dokan_dashboard_content_inside_after' );
                        ?>


                    </div><!-- .dokan-dashboard-content -->

                    <?php
                        /**
                         *  dokan_dashboard_content_after hook
                         *
                         *  @since 2.4
                         */
                        do_action( 'dokan_dashboard_content_after' );
                    ?>

                </div><!-- .dokan-dashboard-wrap -->
              <?php
            }
        }
    }
    new EMV_Dokan_Menu();
}