<?php

if ( ! defined('ABSPATH') ) {
    exit;
}

if ( ! class_exists( 'EMV_Register') ) {
    
    class EMV_Register {
        public function __construct() {
          $disable_phone_number = get_option( 'emv_hide_phone_number', 0 );
            if ( $disable_phone_number != 1 ) {
              add_action('dokan_seller_registration_after_shopurl_field', [ $this, 'register_phone_number' ] );
              add_action('woocommerce_created_customer', [ $this, 'create_customer' ] );
            }
          }
        public function register_phone_number( $postdata ) {
          ?>
            <p class="form-row form-group form-row-wide">
                <label for="EMV_phone_number"><?php esc_html_e( 'WhatsApp Number', 'EMV' ); ?><span class="required">*</span></label>
                <input type="hidden" name="EMV_country_code" id="EMV_country_code" class="EMV_country_code" value="<?php if ( ! empty( $postdata['EMV_country_code'] ) ) { echo esc_attr( $postdata['EMV_country_code'] ); } ?>">
                <input  type="tel" id="EMV_phone" name="EMV_phone_number" class="EMV_phone_number" value="<?php if ( ! empty( $postdata['EMV_phone_number'] ) ) { echo esc_attr( $postdata['EMV_phone_number'] ); } ?>" required="required" >
                <span id="EMV_valid_msg" class="hide"><?php _e( '✓ Valid', 'EMV' );?></span>
                <span style="size:10px" id="EMV_error_msg" class="hide"></span>
            </p>
          <?php
        }  
        /**
         * Save customer information.
         *
         * @version 1.0.0
         */
        public function create_customer($customer_id) {
          
          if ( isset( $_POST['EMV_phone_number'] ) ) {
             $EMV_country_code         = sanitize_text_field($_POST['EMV_country_code']);
             $EMV_phone_number         = sanitize_text_field($_POST['EMV_phone_number']);
             $EMV_Number_with_country  = $EMV_country_code.$EMV_phone_number;
            update_user_meta($customer_id, 'EMV_phone_number',$EMV_Number_with_country );
          }
        }
    }
    new EMV_Register();
}